{-# LANGUAGE TypeOperators,
             FlexibleContexts,
             FlexibleInstances,
             ScopedTypeVariables,
             FunctionalDependencies,
             DeriveGeneric
  #-}

module Stack (push, pop, SState ()) where

import MonadStatePV
import EffectCapabilities
import GHC.Generics

newtype SState a = SState a deriving Generic
instance Capability SState a

push :: MonadStatePV SState n m [s] => s -> m ()
push x = do xs <- get (SState RWPerm)
            put (SState WritePerm) (x:xs)

pop :: MonadStatePV SState n m [s] => m s
pop = do xs <- get (SState ReadPerm)
         put (SState WritePerm) (tail xs)
         return (head xs)